%define rname spank-nvidia
Name:		slurm-%{rname}
Version:	0.2
Release:	1%{?dist}.4
Summary:	Slurm spank plugin to allow use of mps and setting of nvidia gpu modes
License:	Unknown

Source0:	nvidia_spank.c
Source1:	spank_nvidia_prolog.sh
Source2:	spank_nvidia_epilog.sh
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	slurm-devel
Requires:	slurm

%description
This is a SPANK plugin for Slurm to allow users to set nvidia process mode, accounting and mps.

%prep
%setup -T -c -n %{rname}
cp %{SOURCE0} .

%build
gcc -fPIC -shared -g -o nvidia_spank.so nvidia_spank.c

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_libdir}/slurm %{buildroot}/etc/slurm/plugstack.conf.d
install -m 755 nvidia_spank.so %{buildroot}%{_libdir}/slurm
echo "optional %{_libdir}/slurm/nvidia_spank.so" > %{buildroot}/etc/slurm/plugstack.conf.d/nvidia.conf
mkdir -p %{buildroot}/etc/slurm/prolog.d/
install -m 0600 %{SOURCE1} %{buildroot}/etc/slurm/prolog.d/spank_nvidia.sh
mkdir -p %{buildroot}/etc/slurm/epilog.d/
install -m 0600 %{SOURCE2} %{buildroot}/etc/slurm/epilog.d/spank_nvidia.sh

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%{_libdir}/slurm/nvidia_spank.so
%dir /etc/slurm/plugstack.conf.d
/etc/slurm/plugstack.conf.d/nvidia.conf
%dir /etc/slurm/prolog.d
/etc/slurm/prolog.d/*
%dir /etc/slurm/epilog.d/
/etc/slurm/epilog.d/*

%changelog
* Tue Oct 19 2021 Josko Plazonic <plazonic@princetron.edu> 0.2-1.sdl7.1
- adjust to make it work for slurm 21.08

* Mon Oct 09 2017 Josko Plazonic <plazonic@princeton.edu> 0.1-1.sdl6.1
- initial build
